var ife_profiles = new Array();
var ife_currentId = 0;
var ife_OptionsLoaded = 0;

//------------------------------------------------------------------------------
function indexOfProfileId(profileId) 
{
 var index = 0;
 for (var i=0; i<ife_profiles.length; i++)
 {
  if (ife_profiles[i][1] == profileId)
  {
   index = i;
   break;
  }
 }
 return index;
}

//------------------------------------------------------------------------------
function profilesListFill(em_list) 
{
 while (em_list.hasChildNodes())
  em_list.removeChild (em_list.firstChild);

 for (var i=0; i<ife_profiles.length; i++)
 {
  if (ife_profiles[i][1] > 0)
  {
   var newItem = em_list.appendItem(ife_profiles[i][0]);
   newItem.setAttribute("id", ife_profiles[i][1]);
  }
 }
}

//------------------------------------------------------------------------------
function profileListSelect(em_list, profileId) 
{
 var menu_items=em_list.firstChild.childNodes;
 for (var i=0;i<menu_items.length;i++) 
 {
  if (menu_items[i].getAttribute("id")==profileId) 
  {
   em_list.selectedIndex=i;
   break;
  }
 }
}

//------------------------------------------------------------------------------
function buttonDelValidate(em_list) 
{
 var menu_items = em_list.firstChild.childNodes;
 var em_del = document.getElementById("ife_profile_del");
 em_del.setAttribute ("disabled", menu_items.length <= 1);
}

//------------------------------------------------------------------------------
function profileNextNumCreate() 
{
 var result = ife_GetPrefInt("InFormEnter.ProfileNext", 1);
 var nextNum = result;
 if (nextNum < 32000)
  nextNum++;
 else
  nextNum = 0;
 ife_Preferences.setIntPref("InFormEnter.ProfileNext", nextNum);
 return result;
}

//------------------------------------------------------------------------------
function ife_OnOptionsLoad()  
{
 ife_CheckDefaultProfile();

 ///// Profiles /////
 ife_Preferences.setIntPref("InFormEnter.Options", 1); // lame options update

 // profiles list
 var profilesArr = ife_GetPrefChar("InFormEnter.Profiles", "").split("\n");
 var ife_profiles_new = new Array();
 for (var i=0; i<profilesArr.length; i++)
 {
  var tmp = profilesArr[i].split("\t");
  var profileName = unescape(tmp[0]);
  var profileId = tmp[1];
  var menuSet = unescape(ife_GetPrefChar("InFormEnter."+profileId+".MenuSet", ""));
  var showSize = ife_GetPrefInt("InFormEnter."+profileId+".ShowSize", 0);
  var profile = new Array(profileName, profileId, menuSet, showSize);
  ife_profiles_new.push(profile);
 }
 ife_profiles = ife_profiles_new;

 var em_list = document.getElementById("ife_profile_menu");
 profilesListFill(em_list); 
 profileListSelect(em_list, ife_GetPrefInt("InFormEnter.ProfileCurrent", 1));

 buttonDelValidate(em_list);
 ife_OnProfileSelect();

 ///// Other options /////
 var et_enable = document.getElementById("ife_options_enable");
 et_enable.checked = ife_GetPrefInt("InFormEnter.On", 1);

 var ife_MarkersMode = ife_GetPrefInt("InFormEnter.MarkersMode", 1);
 var et_MEnable = document.getElementById("ife_marker_enable");
 et_MEnable.checked = ife_MarkersMode > 0;

 if (ife_MarkersMode < 0)
  ife_MarkersMode *= -1;
 
 var et_MMode = document.getElementById("ife_marker_mode");
 et_MMode.value = ife_MarkersMode;

 ife_OnEnableMarkers();

 var et_Colorize = document.getElementById("ife_colorize_enable");
 var colorize = ife_GetPrefInt("InFormEnter.ColorizeItems2", 0);
 if(!ife_FormHistory) // no interface
  colorize = 0;
 et_Colorize.checked = colorize;
 et_Colorize.setAttribute ("disabled", !ife_FormHistory);

 var et_placement = document.getElementById("ife_options_placement");
 et_placement.selectedIndex = ife_GetPrefInt("InFormEnter.OptionsPlacement", 0);

 var et_MRClick = document.getElementById("ife_options_marker_right_click");
 et_MRClick.selectedIndex = ife_GetPrefInt("InFormEnter.MarkerRightClick", 0);

 ///// Finalize /////
 ife_OptionsLoaded = 1;
 var et_text = document.getElementById("ife_options_text");
 et_text.focus();

 return true;
}

//------------------------------------------------------------------------------
function ife_OnOptionsUnload() 
{
 if (ife_OptionsLoaded)
 {
  window.focus();
  if (window.confirm (ife_GetPropStr("ife.msg.save")))
    ife_OnOptionsAccept(false);
 }
 else
  ife_Preferences.setIntPref("InFormEnter.Options", 0); // lame options update

 return true;
}

//------------------------------------------------------------------------------
function ife_OnProfileSelect()
{
 var index;
 var et_text = document.getElementById("ife_options_text");
 var et_showsize = document.getElementById("ife_options_showsize");

 // save old
 if (ife_currentId != 0)
 {
  index = indexOfProfileId(ife_currentId);
  ife_profiles[index][2] = et_text.value;
  ife_profiles[index][3] = et_showsize.checked;
 }

 // show new 
 var em_list = document.getElementById("ife_profile_menu");
 var menu_items = em_list.firstChild.childNodes;
 var id = menu_items[em_list.selectedIndex].getAttribute("id");
 ife_currentId = id;

 index = indexOfProfileId(id);
 et_text.value = ife_profiles[index][2];
 et_showsize.checked = ife_profiles[index][3];

 return true;
}

//------------------------------------------------------------------------------
function ife_OnProfileAdd()
{
 var profileName = ife_GetPropStr("ife.default.profile.new");

 // prompt service
 var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
 var profileObj = new Object();
 var checkObj = new Object();
 profileObj.value=profileName;
 if(promptService.prompt(window,ife_GetPropStr("ife.prompt.ap.caption"), ife_GetPropStr("ife.prompt.ap.text"), profileObj, null, checkObj) && 
    profileObj.value.length > 0) 
   profileName=profileObj.value;
 else
   return true;
 
 var profileId = profileNextNumCreate();
 ife_profiles.push (new Array(profileName, profileId, "", 0));
 var em_list = document.getElementById("ife_profile_menu");
 profilesListFill(em_list); 
 profileListSelect(em_list, profileId);

 buttonDelValidate(em_list);
 ife_OnProfileSelect();

 return true;
}

//------------------------------------------------------------------------------
function ife_OnProfileRename()
{
 // current 
 var em_list = document.getElementById("ife_profile_menu");
 var menu_items = em_list.firstChild.childNodes;
 var profileName = menu_items[em_list.selectedIndex].getAttribute("label");

 // prompt service
 var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
 var profileObj = new Object();
 var checkObj = new Object();
 profileObj.value=profileName;
 if(promptService.prompt(window,ife_GetPropStr("ife.prompt.rp.caption"), ife_GetPropStr("ife.prompt.rp.text"), profileObj, null, checkObj) && 
    profileObj.value.length > 0) 
   profileName=profileObj.value;
 else
   return true;

 var index = indexOfProfileId(ife_currentId);
 ife_profiles[index][0] = profileName;
 profilesListFill(em_list); 
 profileListSelect(em_list, ife_currentId);

 return true;
}

//------------------------------------------------------------------------------
function ife_OnProfileDel()
{
 var em_list = document.getElementById("ife_profile_menu");
 var menu_items = em_list.firstChild.childNodes;
 var id = menu_items[em_list.selectedIndex].getAttribute("id");

 var profileIdToSelect = 0;
 var profileDeleted = false;
 for (var i=0; i<ife_profiles.length; i++)
 {
  var profileId = ife_profiles[i][1];
  if (profileId == id)
  {
   ife_profiles[i][1] = -id;
   profileDeleted = true;
  }
  else
  {
   if (profileId > 0 && profileIdToSelect == 0)
    profileIdToSelect = profileId;
  }

  if (profileIdToSelect > 0 && profileDeleted)
   break;
 }
 ife_currentId = 0; // don`t save

 profilesListFill(em_list); 
 profileListSelect(em_list, profileIdToSelect);

 buttonDelValidate(em_list);
 ife_OnProfileSelect();

 return true;
}

//------------------------------------------------------------------------------
function ife_OnEnableMarkers()
{
 var et_MEnable = document.getElementById("ife_marker_enable");
 //et_MEnable.checked
 var et_MMode = document.getElementById("ife_marker_mode");
 et_MMode.disabled = !et_MEnable.checked;
}

//------------------------------------------------------------------------------
function ife_OnWarningColorize()
{
 var et_Colorize = document.getElementById("ife_colorize_enable");
 if (et_Colorize.checked)
  alert (ife_GetPropStr("ife.msg.warning.colorize"));
}

//------------------------------------------------------------------------------
function ife_OnOptionsAccept(toCloseWindow) 
{
 ///// Profiles /////
 // current profile data
 var index = indexOfProfileId(ife_currentId);
 var et_text = document.getElementById("ife_options_text");
 var et_showsize = document.getElementById("ife_options_showsize");

 ife_profiles[index][2] = et_text.value;
 ife_profiles[index][3] = et_showsize.checked;

 // all profiles
 var profilesStr = "";
 for (var i=0; i<ife_profiles.length; i++)
 {
  var profileId = ife_profiles[i][1];
  if (profileId > 0) 
  {
   // to save profile
   var profileName = ife_profiles[i][0];
   var menuSet = ife_profiles[i][2];
   var showSize = ife_profiles[i][3];
   
   //
   if (profilesStr != "")
    profilesStr += "\n";
   profilesStr += (escape(profileName) + "\t" + profileId);

   //  
   ife_Preferences.setCharPref("InFormEnter."+profileId+".MenuSet", escape(menuSet));
   ife_Preferences.setIntPref("InFormEnter."+profileId+".ShowSize", showSize);
  }
  else
  {
   // to delete profile
   ife_Preferences.deleteBranch ("InFormEnter."+profileId+".MenuSet");
   ife_Preferences.deleteBranch ("InFormEnter."+profileId+".ShowSize");
  }
 }
 ife_Preferences.setCharPref("InFormEnter.Profiles", profilesStr);

 // current Id
 if (ife_currentId != 0)
  ife_Preferences.setIntPref("InFormEnter.ProfileCurrent", ife_currentId);

 ///// Other options /////
 var et_enable = document.getElementById("ife_options_enable");
 ife_Preferences.setIntPref("InFormEnter.On", et_enable.checked);

 var et_MEnable = document.getElementById("ife_marker_enable");
 var et_MMode = document.getElementById("ife_marker_mode");
 var ife_MarkersMode = et_MMode.value;
 if (!et_MEnable.checked)
  ife_MarkersMode *= -1;

 ife_Preferences.setIntPref("InFormEnter.MarkersMode", ife_MarkersMode);

 var et_Colorize = document.getElementById("ife_colorize_enable");
 ife_Preferences.setIntPref("InFormEnter.ColorizeItems2", et_Colorize.checked);

 var et_placement = document.getElementById("ife_options_placement");
 ife_Preferences.setIntPref("InFormEnter.OptionsPlacement", et_placement.selectedIndex);

 var et_MRClick = document.getElementById("ife_options_marker_right_click");
 ife_Preferences.setIntPref("InFormEnter.MarkerRightClick", et_MRClick.selectedIndex);

 ///// Finalize /////
 ife_OptionsLoaded = 0;
 
 if (toCloseWindow)
  window.close();

 return true;
}

//------------------------------------------------------------------------------
function ife_OnOptionsCancel() 
{
 ife_OptionsLoaded = 0;
 window.close();
 return true;
}
