// global variables ------------------------------------------------------------
var ife_MarkerNumber = 0;
var ife_LastInput = null;
var ife_LastPopupMenu = null;
var ife_IsActiveMarker = false;
var ife_ActiveMarkers = [];
var ife_AutofloatStyleHide = "vertical-align:bottom; display: none; border: 0;";
var ife_AutofloatStyleShow = "vertical-align:bottom; display: inline; border: 0; position:absolute; cursor:pointer;"
var ife_LastFocusURL = "";

//------------------------------------------------------------------------------
function ife_OnMenuItemSelect(index, event)
{
 var menuTextItems = unescape(ife_MenuSet).split("\n"); 
 if (index>=0 && index<menuTextItems.length)
 {
  var et_input = ife_LastInput;
  if (et_input)
  {
   var menu_value = "";
   var line = menuTextItems[index];
   if (line.length > 0)
   {
    line=ife_HideSharp(line);
    var tmp = line.split ("#");
    if (tmp.length > 1)
    {
     var arraySize = tmp.length;
     if (arraySize == 2) // no macros
      menu_value = ife_HideAt(ife_UnhideSharp(tmp[0]));
     else
      menu_value = ife_Macro(tmp[arraySize-2], true);
    }
    else 
     menu_value = ife_HideAt(ife_UnhideSharp(line));
   }
   
   var pos2Sel;
   if (event.ctrlKey)
   {
    var s1 = et_input.value.substr(0, et_input.selectionStart);
    var s2 = et_input.value.substr(et_input.selectionEnd);
    et_input.value = s1 + menu_value + s2;
    pos2Sel = s1.length + menu_value.length;
   }
   else
   {
    et_input.value = menu_value;
    pos2Sel = menu_value.length;
   }

   et_input.focus();
   et_input.setSelectionRange(pos2Sel,pos2Sel);
  }
  
 }
}

//------------------------------------------------------------------------------
function ife_Add2Profile()
{
  var et_input = ife_LastInput;

  if (et_input && et_input.value.length > 0)
  {
   var newEntry;
   if (et_input.selectionStart == et_input.selectionEnd)
    newEntry = et_input.value;
   else
    newEntry = et_input.value.substr(et_input.selectionStart, et_input.selectionEnd);

   var profileId = ife_GetPrefInt("InFormEnter.ProfileCurrent", 1);
   ife_MenuSet = unescape(ife_GetPrefChar("InFormEnter."+profileId+".MenuSet", ""));
   ife_MenuSet = newEntry.replace(/\n/g, "@@") + "\n" + ife_MenuSet;
   ife_Preferences.setCharPref("InFormEnter."+profileId+".MenuSet", escape(ife_MenuSet));
  }
}

//------------------------------------------------------------------------------
function ife_CheckMarkerClick(event)
{
 var markerID = event.target.id.toString();
 var pos = markerID.indexOf ("_ife_marker_");
 if(pos != -1) // over ife marker
 {
  if(event.button == 0 ||  // left mouse click
     (event.button == 2 && ife_MarkerRightClick == 1)) // right mouse click && show main menu
  {
   var et_marker = event.target;
   var et_input = et_marker.previousSibling;
   ife_LastInput = et_input;
   var maxlength = et_input.getAttribute("maxlength");

   et_input.focus();
   ife_PopupFill('ife_popup_mi_hint', et_input.name, maxlength); 

   var pm1 = document.getElementById("ife_popup");
   ife_LastPopupMenu = pm1;
   pm1.showPopup(document.documentElement,
                 event.screenX + 7,                     // 14 is markers width
                 event.screenY - ife_MenuItemsCount*10 - 20, // 20 is average menu item height
                 "popup","bottomleft","topleft");
  }

  if(event.button == 2 && ife_MarkerRightClick == 0) // right mouse click && show profiles list
  {
   ife_CheckDefaultProfile();

   var pm2 = document.getElementById("informenter-popup");
   ife_LastPopupMenu = pm2;
   pm2.showPopup(document.documentElement,
                 event.screenX,
                 event.screenY - 20,
                 "popup","bottomleft","topleft");
  }

  return false;
 }
}

//------------------------------------------------------------------------------
function ife_CheckMarkerDoubleClick(event)
{
 var markerID = event.target.id.toString();
 var pos = markerID.indexOf ("_ife_marker_");
 if(pos != -1) // over ife marker
 {
   var et_marker = event.target;
   if(et_marker.getAttribute("src").indexOf("informenter/skin/marker_inhistory_one.png") != -1)
   {
    var et_input = et_marker.previousSibling;
    et_input.value = ife_GetCurrentProfileFirstItemFromFormCache (et_input.getAttribute("name"));
    ife_LastPopupMenu.hidePopup(); 
    return false;
  }
 }
}

//------------------------------------------------------------------------------
function ife_CheckAccelKey(event)
{
 var focused_input = document.commandDispatcher.focusedElement;
 if(!focused_input || !focused_input.nextSibling || !focused_input.nextSibling.id)
  return; // not input with markers

 var markerID = focused_input.nextSibling.id.toString();
 var pos = markerID.indexOf ("_ife_marker_");
 if(pos != -1) // in fine input
 {
   var et_input = focused_input;
   ife_LastInput = et_input;
   var maxlength = et_input.getAttribute("maxlength");

   ife_PopupFill('ife_popup_mi_hint', et_input.name, maxlength); 

   var x,y;
   var tb = document.getElementById("navigator-toolbox");
   if (tb)
   {
    x = tb.boxObject.screenX; 
    y = tb.boxObject.screenY+tb.boxObject.height;
   }
   else
   {
    x = window.screenX;
    y = window.screenY+120;
   }

   //x += (ife_GetClientX (et_input) - window._content.scrollX + 20); 
   //y += (ife_GetClientY (et_input) - window._content.scrollY + et_input.clientHeight/2 - ife_MenuItemsCount*10 - 20); // 20 is average menu item height;
   var point = ife_GetElementXY (et_input);
   x += (point.x - window._content.scrollX + 20); 
   y += (point.y - window._content.scrollY + et_input.clientHeight/2 - ife_MenuItemsCount*10 - 20); // 20 is average menu item height;

   var pm = document.getElementById("ife_popup");
   pm.showPopup(document.documentElement,
                x,
                y,
                "popup","bottomleft","topleft");
 }

 return true;
}

//------------------------------------------------------------------------------
function ife_OnContextPopupShowing()
{
 var isHidden = true;
 if (ife_On && gContextMenu != null && gContextMenu.onTextInput)
 {
  isHidden = false;
  ife_LastInput = gContextMenu.target;
 }
 document.getElementById("ife_context").hidden = isHidden;
}

//------------------------------------------------------------------------------
function ife_OnContextSubPopupShowing()
{
 if (ife_On)
 {
  if (gContextMenu != null && gContextMenu.onTextInput && ife_LastInput != null)
  {
   var et_input = ife_LastInput;
   if (et_input != null)
   {
    var maxlength = et_input.getAttribute("maxlength");
    ife_PopupFill('ife_context_popup_mi_hint', et_input.name, maxlength); 
   }
  }
 }
}

//------------------------------------------------------------------------------
function ife_OnOptions()
{
 window.openDialog("chrome://informenter/content/ife_options.xul","ife_options","chrome,centerscreen,modal,resizable");
 ife_RemoveMarkers(window._content); // to change markers style
 ife_ProcessPage(null, "load");
}

//------------------------------------------------------------------------------
function ife_OnProfileCurrent(profileId)
{
 ife_Preferences.setIntPref("InFormEnter.ProfileCurrent", profileId);
 if(ife_On)
 {
  // to reload markers 
  ife_RemoveMarkers(window._content); 
  ife_ProcessPage(null, "load");
 }
}

//------------------------------------------------------------------------------
function ife_OnProfilesMenu(menu_item_id)
{
 ife_CheckDefaultProfile();

 var profilesArr = ife_GetPrefChar("InFormEnter.Profiles", "").split("\n");
 var profileCurrentId = ife_GetPrefInt("InFormEnter.ProfileCurrent", 1);
 var mi_profile = document.getElementById(menu_item_id);

 // remove previous menu
 while (mi_profile.nextSibling != null)
  mi_profile.parentNode.removeChild (mi_profile.nextSibling);

 // template
 var mi_template = mi_profile.cloneNode(true);
 mi_template.setAttribute("hidden", false);

 // create new items
 var menuItemsCount = 0;
 for (var i=0; i<profilesArr.length; i++)
 {
  var profileData = profilesArr[i].split("\t");
  var mi_new = mi_template.cloneNode(true);
  mi_new.setAttribute("label", unescape(profileData[0]));
  mi_new.setAttribute("oncommand", "ife_OnProfileCurrent(" + profileData[1] + ");");
  if (profileCurrentId == profileData[1])
   mi_new.setAttribute("checked", true);
  mi_profile.parentNode.appendChild (mi_new);
 }
}

//------------------------------------------------------------------------------
function ife_ShowCurrentState() 
{
 // Read state
 ife_On = ife_GetPrefInt("InFormEnter.On", 1);
 ife_OptionsPlacement = ife_GetPrefInt("InFormEnter.OptionsPlacement", 0);
 ife_MarkerRightClick = ife_GetPrefInt("InFormEnter.MarkerRightClick", 0);
 ife_MarkersMode = ife_GetPrefInt("InFormEnter.MarkersMode", 1);
 ife_ColorizeItems = ife_GetPrefInt("InFormEnter.ColorizeItems2", 0);

 // On\Off
 var sbpi = document.getElementById('informenter-status');
 sbpi.setAttribute("status", ife_On ? "on" : "off");
 sbpi.setAttribute("tooltip", ife_On ? "informenter-tooltip-on" : "informenter-tooltip-off" );

 // Options Placement
 document.getElementById('informenter-status').setAttribute("hidden", ife_OptionsPlacement==0 ? "false" : "true");
 document.getElementById('informenter-menu').setAttribute("hidden", ife_OptionsPlacement==1 ? "false" : "true");

 // Context menu
 var menu = document.getElementById("contentAreaContextMenu");
 menu.addEventListener("popupshowing", ife_OnContextPopupShowing, false);
}

//------------------------------------------------------------------------------
function ife_OnStatusClick(event) 
{
 if (event.button == 2) // right mouse click
 {
  ife_On = !ife_On;
  ife_Preferences.setIntPref("InFormEnter.On", ife_On);
  ife_ProcessPage(null, "load");
 }
}

//------------------------------------------------------------------------------
// Floating markers

function ife_CheckActiveMarker()
{
 if (ife_ActiveMarkers.length && ife_IsActiveMarker == false)
 {
  for (var i=ife_ActiveMarkers.length-1; i>=0; i--)
   ife_ActiveMarkers[i].setAttribute("style", ife_AutofloatStyleHide);
  ife_ActiveMarkers = [];
  ife_IsActiveMarker = false;
 }
}

function ife_RegisterPageEventers (windowCurrent)
{
 // Process self frame //
 var doc = windowCurrent.document;

 var dw = new XPCNativeWrapper (doc.defaultView).wrappedJSObject;

 dw.ife_OnInputOver = function (event)
 {
  if(ife_MarkersMode == 3) // autofloat markers
  {
   event.target.nextSibling.setAttribute("style", ife_AutofloatStyleShow);

   //var x=ife_GetClientX(event.target) + event.target.offsetWidth - event.target.nextSibling.offsetWidth - 1;
   //var y=ife_GetClientY(event.target) + event.target.offsetHeight - event.target.nextSibling.offsetHeight - 1;
   var point = ife_GetElementXY (event.target);
   var x = point.x + event.target.offsetWidth - event.target.nextSibling.offsetWidth - 1;
   var y = point.y + event.target.offsetHeight - event.target.nextSibling.offsetHeight - 1;

   event.target.nextSibling.style.top = y+"px";
   event.target.nextSibling.style.left = x+"px";

   ife_IsActiveMarker = true;
   ife_ActiveMarkers.push(event.target.nextSibling);
  }
 }

 dw.ife_OnInputOut = function ()
 {
  if(ife_MarkersMode == 3) // autofloat markers
  {
   ife_IsActiveMarker = false;
   window.setTimeout("ife_CheckActiveMarker();", 200);
  }
 }

 dw.ife_OnMarkerOver = function ()
 {
  if(ife_MarkersMode == 3) // autofloat markers
  {
   ife_IsActiveMarker = true;
  }
 }

 dw.ife_OnMarkerOut = function ()
 {
  if(ife_MarkersMode == 3) // autofloat markers
  {
   ife_IsActiveMarker = false;
   window.setTimeout("ife_CheckActiveMarker();", 200);
  }
 }

 // Process subframes //
 for (var i=0; i<windowCurrent.frames.length; i++)
  ife_RegisterPageEventers(windowCurrent.frames[i]);
}

//------------------------------------------------------------------------------
function ife_AttachMarker(doc,field,checkFormCache) 
{
 var markerNeed = false;

 if (field.nextSibling != null)
 {
  try   
  {
   var className = field.nextSibling.getAttribute("class");
   if (className.indexOf ("ife_marker") == -1)
    markerNeed = true;
  }
  catch (e)
  {
   markerNeed = true;
  }
 }
 else
  markerNeed = true;

 if (markerNeed)
 {
  // img
  var imgNode = doc.createElement("img");
  imgNode.setAttribute("id", field.getAttribute("name") + "_ife_marker_" + ife_MarkerNumber);
  if(checkFormCache && ife_FormHistory && ife_On && ife_ColorizeItems)
  {
    var itemsCount = ife_GetCurrentProfileItemsCountInFormCache(field.name);
    if(itemsCount > 1)
     imgNode.setAttribute("src", "chrome://informenter/skin/marker_inhistory.png");
    if(itemsCount == 1)
     imgNode.setAttribute("src", "chrome://informenter/skin/marker_inhistory_one.png");
    if(itemsCount == 0)
     imgNode.setAttribute("src", "chrome://informenter/skin/marker.png");
  }
  else
   imgNode.setAttribute("src", "chrome://informenter/skin/marker.png");

  imgNode.setAttribute("class", "ife_marker");
  var styleAttribute = "border: 0; width: 14px; height: 19px; cursor:pointer;";
  if (ife_MarkersMode < 0)
   styleAttribute += " display:none;";
  if(ife_MarkersMode < 3) // not autofloat markers
  {
   imgNode.setAttribute("style", styleAttribute);
   imgNode.setAttribute("align", "absmiddle");
  }

  var maxlength = field.getAttribute("maxlength");
  imgNode.setAttribute("title", ife_StrMaxInputLength (maxlength));
  
  field.parentNode.insertBefore (imgNode, field.nextSibling);

  // MM==2
  if(ife_MarkersMode == 2) // reduce inputs width
  {
   var newWidth = field.offsetWidth;
   if (newWidth >= 36)
   {
    newWidth -= 18; 
    field.style.width = newWidth+"px"; 
   }
  }

  // MM==3
  if(ife_MarkersMode == 3) // autofloat markers
  {
   field.setAttribute("onmouseover", "ife_OnInputOver(event);");
   field.setAttribute("onmouseout", "ife_OnInputOut();");

   imgNode.setAttribute("style", ife_AutofloatStyleHide);

   imgNode.setAttribute("onmouseover", "ife_OnMarkerOver();");
   imgNode.setAttribute("onmouseout", "ife_OnMarkerOut();");
   //imgNode.onmouseover = ife_OnMarkerOver;
   //imgNode.addEventListener("onmouseout",ife_OnMarkerOver,false);
  }

  // 
  ife_MarkerNumber++;
 }
}

//------------------------------------------------------------------------------
function ife_AddMarkers(windowCurrent) 
{
 // Process self frame //
 var doc = windowCurrent.document;
 var inputs = doc.getElementsByTagName("input");

 // markers to inputs
 for (var i=0; i<inputs.length; i++)
 {
  var input = inputs[i];
  var type = input.getAttribute("type");
  if (type == null || type == "" || type == "text" || type == "password" || type == "search")
  {
   if(ife_IsInputVisibleAndEditable(input))
    ife_AttachMarker(doc,input,true);
  }
 }

 // markers to textareas
 inputs = doc.getElementsByTagName("textarea");
 for (i=0; i<inputs.length; i++)
 {
  if(ife_IsInputVisibleAndEditable(inputs[i]))
   ife_AttachMarker(doc,inputs[i],false);
 }

 // Process subframes //
 for (i=0; i<windowCurrent.frames.length; i++)
  ife_AddMarkers(windowCurrent.frames[i]);
}

//------------------------------------------------------------------------------
function ife_RemoveMarkers(windowCurrent) 
{
 // Process self frame //
 var doc = windowCurrent.document;

 var images = doc.getElementsByTagName("img");
 for (var i=images.length-1; i>=0; i--)
 {
  var image = images[i];
  var className = image.getAttribute("class");
  if (className != null && className.indexOf("ife_marker") != -1)
   image.parentNode.removeChild (image);
 }

 // Process subframes //
 for (i=0; i<windowCurrent.frames.length; i++)
  ife_RemoveMarkers(windowCurrent.frames[i]);
}

//------------------------------------------------------------------------------
function ife_ProcessPage(event, event_type) 
{
 // check double events
 var breakProcess = 0;
 var ife_current_href = window._content.document.location.href.toString();

 if(event_type == "load")
 {
  var ife_loaded_href = "";
  if(event != null)
  {
   event.originalTarget.ife_document_is_loaded = 1;
   ife_loaded_href = event.originalTarget.location.href.toString();
   
   //if(ife_current_href != ife_loaded_href) // frames!
   // breakProcess = 1;
  }
 }
 var ife_document_is_loaded = window._content.document.ife_document_is_loaded;

 if(event_type == "focus")
 {
  if(ife_document_is_loaded && ife_current_href == ife_LastFocusURL) // #1=repeated next focusing 
   breakProcess = 1;
  if(!ife_document_is_loaded) // #2=repeated previous focusing
   breakProcess = 1;
  
  ife_LastFocusURL = ife_current_href;
 }

 if(breakProcess)
  return;

 //ddd("ife_ProcessPage:"+event_type+"; "+ife_current_href);

 // page process 
 ife_MarkerNumber = 0;
 if (ife_On)
 {
  ife_AddMarkers(window._content);
  window.onclick=ife_CheckMarkerClick;
  window.ondblclick=ife_CheckMarkerDoubleClick;

  if(ife_MarkersMode == 3) // autofloat markers
  {
   if(ife_MarkerNumber > 0) // markers rebuilded
   {
    ife_IsActiveMarker = false;
    ife_ActiveMarkers = [];
   }
   ife_RegisterPageEventers(window._content);
  }
 }
 else
  ife_RemoveMarkers(window._content); 

 ife_ShowCurrentState();
}

//------------------------------------------------------------------------------
window.addEventListener("DOMContentLoaded",function(event) {ife_ProcessPage(event, "load");},true);
window.addEventListener("focus",function(event) {ife_ProcessPage(event, "focus");},true);
